local metadata = {
"## Interface:FS15 1.1.0.0 RC12",
"## Title: SchlammLoch",
"## Notes: SchlammLoch",
"## Author: Marhu",
"## Version: 1.0.1-19",
"## Date: 19.03.2016",
"## Web: http://marhu.net"
}

local DebugEbene = 0;
local function getmdata(v) v="## "..v..": "; for i=1,table.getn(metadata) do local _,n=string.find(metadata[i],v);if n then return (string.sub (metadata[i], n+1)); end;end;end;
local function Debug(e,s,...) if e <= DebugEbene then print((getmdata("Title")).." v"..(getmdata("Version"))..": "..string.format(s,...)); end; end;
local function L(name) local t = getmdata("Title"); return g_i18n:hasText(t.."_"..name) and g_i18n:getText(t.."_"..name) or name; end
--print("Script "..(getmdata("Title")).." v"..(getmdata("Version")).." by "..(getmdata("Author")).." loaded! Support on "..(getmdata("Web")));

FruitUtil.registerFruitType("dirty", "dirty", true, true, false, 0, 4, 6, 8, false, 1, 1, 1, false);

SchlammLoch = {}
SchlammLoch.modDir = g_currentModDirectory

function SchlammLoch:loadMap(name)
	local modName, baseDirectory = Utils.getModNameAndBaseDirectory(name)
	if baseDirectory == SchlammLoch.modDir then
		local numVehicleTypes = 0;
		self.terrainControlSpezi = SpecializationUtil.getSpecialization(modName..".terrainControl");
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
			if not SpecializationUtil.hasSpecialization(self.terrainControlSpezi, v.specializations) then
				table.insert(v.specializations, self.terrainControlSpezi);
				numVehicleTypes = numVehicleTypes + 1;
			end;
		end;
		
		print("Script "..(getmdata("Title")).." v"..(getmdata("Version")).." by "..(getmdata("Author")).." registered in "..numVehicleTypes.." vehicleTypes! Support on "..(getmdata("Web")));
		
		local i3dFilename = SchlammLoch.modDir.."scripts/dirtPS/dirt_1.i3d";
		if fileExists(i3dFilename) then
			local dirtRoot = Utils.loadSharedI3DFile(i3dFilename);
			terrainControl.dirtWave = getChildAt(dirtRoot, 0);
			link(getRootNode(), terrainControl.dirtWave);
			delete(dirtRoot);
			setVisibility(terrainControl.dirtWave, false);
		end;
		
		SchlammLoch.org_updateWheelsGraphics = WheelsUtil.updateWheelsGraphics;
		SchlammLoch.org_getDriveGroundParticleSystemsScale = Vehicle.getDriveGroundParticleSystemsScale;
		SchlammLoch.org_updateWheelBase = Vehicle.updateWheelBase;
		
		WheelsUtil.updateWheelsGraphics = SchlammLoch.updateWheelsGraphics;
		Vehicle.getDriveGroundParticleSystemsScale = SchlammLoch.getDriveGroundParticleSystemsScale;
		Vehicle.updateWheelBase = SchlammLoch.updateWheelBase;
	end;
end;
function SchlammLoch:deleteMap()
	if self.terrainControlSpezi then
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
			for num, specialization in pairs(v.specializations) do
				if specialization == self.terrainControlSpezi then
					table.remove(v.specializations, num);
					break;
				end;
			end;
		end;
		self.terrainControlSpezi = nil;
	end;
	if SchlammLoch.org_updateWheelsGraphics then
		WheelsUtil.updateWheelsGraphics = SchlammLoch.org_updateWheelsGraphics;
		SchlammLoch.org_updateWheelsGraphics = nil;
	end
	if SchlammLoch.org_getDriveGroundParticleSystemsScale then
		Vehicle.getDriveGroundParticleSystemsScale = SchlammLoch.org_getDriveGroundParticleSystemsScale;
		SchlammLoch.org_getDriveGroundParticleSystemsScale = nil;
	end
	if SchlammLoch.org_updateWheelBase then
		Vehicle.updateWheelBase = SchlammLoch.org_updateWheelBase;
		SchlammLoch.org_updateWheelBase = nil;
	end
end;
function SchlammLoch:mouseEvent(posX, posY, isDown, isUp, button)
end;
function SchlammLoch:keyEvent(unicode, sym, modifier, isDown)
end;
function SchlammLoch:update(dt)
end;
function SchlammLoch:draw()
end;

-- overwritten Functions ---

function SchlammLoch.updateWheelsGraphics(self, dt)
	if self.isServer then
		self.hasWheelGroundContact = false;
	end;
	for i, wheel in pairs(self.wheels) do
		WheelsUtil.updateWheelSteeringAngle(self, wheel, dt);
		if self.isServer then
			WheelsUtil.updateWheelHasGroundContact(wheel);
			if wheel.hasGroundContact then
				self.hasWheelGroundContact = true;
			end;
			local x,y,z, xDrive = getWheelShapePosition(wheel.node, wheel.wheelShape);
			WheelsUtil.updateWheelGraphics(self, wheel, x, y, z, xDrive);
			--fill netinfo (on server)
			wheel.netInfo.x = x;
			wheel.netInfo.y = y;
			wheel.netInfo.z = z;
			wheel.netInfo.xDrive = xDrive;
		else
			-- client code
			local x, y, z = wheel.netInfo.x, wheel.netInfo.y, wheel.netInfo.z;
			if self:getLastSpeed(true) > 0 and wheel.tireType ~= 4 then
				if wheel.lastYnetInfo then
					if math.abs(math.abs(wheel.lastYnetInfo)-math.abs(y)) > 0.02 then
						if wheel.lastYnetInfo < y then
							y = wheel.lastYnetInfo+0.02;
						else
							y = wheel.lastYnetInfo-0.02;
						end;
					end;
				end;
				wheel.lastYnetInfo = y;
			end;
			local xDrive = wheel.netInfo.xDrive;
			WheelsUtil.updateWheelGraphics(self, wheel, x, y, z, xDrive);
		end;
	end;
end;

function SchlammLoch:updateWheelBase(wheel, dirt)
    local inDirt = Utils.getNoNil(dirt, false);
	local positionY = wheel.positionY+wheel.deltaY;
    if self.isServer then
        local collisionMask = 255 - 4; -- all up to bit 8, except bit 2 which is set by the players kinematic object
        wheel.wheelShape = createWheelShape(wheel.node, wheel.positionX, positionY, wheel.positionZ, wheel.radius, wheel.suspTravel, wheel.spring, wheel.damper, wheel.mass, collisionMask, wheel.wheelShape);
        local forcePointY = positionY - wheel.radius * wheel.forcePointRatio;
        setWheelShapeForcePoint(wheel.node, wheel.wheelShape, wheel.positionX, forcePointY, wheel.positionZ);
    end;
	if not inDirt then
		wheel.netInfo = {};
		wheel.netInfo.xDrive = 0;
		wheel.netInfo.x = wheel.positionX;
		wheel.netInfo.y = positionY;
		wheel.netInfo.z = wheel.positionZ;
		-- The suspension elongates by 20% of the specified susp travel
		wheel.netInfo.yMin = positionY-1.2*wheel.suspTravel;
		wheel.netInfo.yRange = 1.2*wheel.suspTravel;
		if wheel.netInfo.yRange < 0.001 then
			-- avoid division by 0
			wheel.netInfo.yRange = 0.001;
		end;
	end;
    if wheel.driveGroundParticleSystem ~= nil then
        local wx, wy, wz = worldToLocal(wheel.node, getWorldTranslation(wheel.driveNode));
        setTranslation(wheel.driveGroundParticleSystem.rootNode, wx + wheel.driveGroundParticleSystem.offsets[1], wy - wheel.radius + wheel.driveGroundParticleSystem.offsets[2], wz + wheel.driveGroundParticleSystem.offsets[3]);
    end;
end;

function SchlammLoch:getDriveGroundParticleSystemsScale(particleSystem)
    local wheel = particleSystem.wheel;
    if wheel ~= nil then
        if (particleSystem.onlyActiveOnGroundContact and wheel.contact ~= Vehicle.WHEEL_GROUND_CONTACT) or wheel.inDirt then
            return 0;
        end;
        if math.abs(wheel.lastColor[1]-0.275) <= 0.001 and math.abs(wheel.lastColor[2]-0.212) <= 0.001 and math.abs(wheel.lastColor[3]-0.160) <= 0.001 then
            return 0;
        end;
    end;
    local minSpeed = particleSystem.minSpeed;
    local direction = particleSystem.direction;
	if self.lastSpeedReal > minSpeed and (direction == 0 or (direction > 0) == (self.movingDirection > 0)) then
		local maxSpeed = particleSystem.maxSpeed;
		local alpha = math.min((self.lastSpeedReal - minSpeed) / (maxSpeed - minSpeed), 1);
		local scale = Utils.lerp(particleSystem.minScale, particleSystem.maxScale, alpha);
		return scale;
	end;
    return 0;
end;

addModEventListener(SchlammLoch);